package controller;

import java.io.IOException;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.TextArea;
import javafx.stage.Stage;

public class StandardArrayController {
	@FXML
	private TextArea standardArray;

	private String[][] syndtable;

	public StandardArrayController() {

	}

	@FXML
	protected void close(ActionEvent event) throws IOException {
		Node source = (Node) event.getSource();
		Stage stage = (Stage) source.getScene().getWindow();
		stage.close();
	}

	@FXML
	public void initialize() {

		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < syndtable.length; i++) {
			for (String s : syndtable[i]) {
				sb.append(s + " ");
			}
			sb.append("\n");
		}

		standardArray.setText(sb.toString());
	}

	public void initData(String[][] syndTable) {
		this.syndtable = syndTable;
	}

}
