% Criptosistema de McEliece con Hamming(7,4)
clear all
clc

%%%%%%%%%%%%%%
% Alice
%%%%%%%%%%%%%%

C = [ 1 1 0; 1 0 1; 0 1 1; 1 1 1;]

S = [1 1 0 1;1 0 0 1;0 1 1 1;1 1 0 0]
G = [eye(4) C]
P = [0 1 0 0 0 0 0;0 0 0 1 0 0 0;0 0 0 0 0 0 1;1 0 0 0 0 0 0;0 0 1 0 0 0 0;0 0 0 0 0 1 0;0 0 0 0 1 0 0]
H = [C' eye(3)]

syntable = syndtable(H)

GP = mod(S*G*P,2)

%%%%%%%%%%%%%%
% Bob
%%%%%%%%%%%%%%

MSG = [1 1 0 1]

E = [ 0 0 0 0 1 0 0 ]

eee = [
    1 0 0 0 0 0 0
    0 1 0 0 0 0 0
    0 0 1 0 0 0 0
    0 0 0 1 0 0 0
    0 0 0 0 1 0 0
    0 0 0 0 0 1 0
    0 0 0 0 0 0 1
     ];

result = []
for j=1:1:7
    disp('##############################')
    E = eee(j,:)

Y = mod(MSG*GP+E,2)

%%%%%%%%%%%%%%
% Alice
%%%%%%%%%%%%%%



YP = mod(Y*inv(P),2)

syn = mod(YP*H',2)
synrow = bi2de(fliplr(syn))

ERROR = syntable(synrow+1,:)

YPP = mod(YP+ERROR,2)

RES = mod(YPP(1:4)*inv(S),2)
result = [result ; RES]
end

