% Criptosistema de Niederreiter con Hamming(7,4)
clear all
clc

%%%%%%%%%%%%%%
% Alice
%%%%%%%%%%%%%%

C = [ 1 1 0; 1 0 1; 0 1 1; 1 1 1;]

S = [1 1 0;1 0 0;1 1 1]
G = [eye(4) C]
P = [0 1 0 0 0 0 0;0 0 0 1 0 0 0;0 0 0 0 0 0 1;1 0 0 0 0 0 0;0 0 1 0 0 0 0;0 0 0 0 0 1 0;0 0 0 0 1 0 0]
H = [C' eye(3)]
%syntable = syndtable(H)

HP = mod(S*H*P,2)

%%%%%%%%%%%%%%
% Bob
%%%%%%%%%%%%%%

MSG = [0 0 0 0 0 1 0]

c=HP*MSG'

%%%%%%%%%%%%%%
% Alice
%%%%%%%%%%%%%%

cp = mod(inv(S)*c,2)

cpp = 1

pp =[1 0 0 0 0 0 0; 0 1 0 0 0 0 0; 0 0 1 0 0 0 0; 0 0 0 1 0 0 0 ; 0 0 0 0 1 0 0 ; 0 0 0 0 0 1 0 ; 0 0 0 0 0 0 1]

syntables = []

for k=1:1:7
   syntables = [syntables; pp(k,:)*H'] 
end

for k=1:1:7
   if syntables(k,1)==cp(1) &  syntables(k,2)==cp(2) & syntables(k,3)==cp(3)
       cpp=pp(k,:)
   end
end

m = cpp*inv(P)'


